diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/config.in linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/config.in
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/config.in	2004-08-03 19:25:37.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/config.in	2005-08-12 15:41:58.000000000 -0600
@@ -556,6 +556,13 @@ if [ "$CONFIG_SA1100_ACCELENT" = "y" ]; 
    fi
 fi
 bool 'Networking support' CONFIG_NET
+
+tristate 'Adeos support' CONFIG_ADEOS
+if [ "$CONFIG_ADEOS" != "n" ]; then
+   define_bool CONFIG_ADEOS_CORE y
+   bool 'Adeos domains are threads' CONFIG_ADEOS_THREADS
+fi
+
 bool 'System V IPC' CONFIG_SYSVIPC
 bool 'BSD Process Accounting' CONFIG_BSD_PROCESS_ACCT
 bool 'Sysctl support' CONFIG_SYSCTL
@@ -789,7 +796,9 @@ if [ "$CONFIG_ARCH_OMAHA" = "y" ]; then
     # -- ahaigh@arm.com (23 August 2002)
     define_bool CONFIG_FRAME_POINTER n
 else
+    if [ "$CONFIG_ARCH_EP9301" != "y" ]; then
     define_bool CONFIG_FRAME_POINTER y
+    fi
 fi
 
 bool 'Verbose user fault messages' CONFIG_DEBUG_USER
@@ -797,6 +806,9 @@ bool 'Include debugging information in k
 dep_bool 'Disable pgtable cache' CONFIG_NO_PGT_CACHE $CONFIG_CPU_26
 
 bool 'Kernel debugging' CONFIG_DEBUG_KERNEL
+if [ "$CONFIG_ARCH_EP9301" = "y" ]; then
+    dep_bool '  Compile Kernel with frame pointers' CONFIG_FRAME_POINTER $CONFIG_DEBUG_KERNEL
+fi
 dep_bool '  Debug memory allocations' CONFIG_DEBUG_SLAB $CONFIG_DEBUG_KERNEL
 dep_bool '  Magic SysRq key' CONFIG_MAGIC_SYSRQ $CONFIG_DEBUG_KERNEL
 dep_bool '  Spinlock debugging' CONFIG_DEBUG_SPINLOCK $CONFIG_DEBUG_KERNEL
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/adeos.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/adeos.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/adeos.c	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/adeos.c	2005-08-12 15:41:58.000000000 -0600
@@ -0,0 +1,527 @@
+/*
+ *   linux/arch/arm/kernel/adeos.c
+ *
+ *   Copyright (C) 2002-2005 Philippe Gerum.
+ *
+ *   Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ *   	various tweaks, fixes (e.g. call asm_do_IRQ() instead of do_IRQ() and
+ *   	optimizations, backport of unthreaded support from Adeos/x86 for 2.6
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS core support for ARM.
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/smp.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/bitops.h>
+#include <asm/system.h>
+#include <asm/atomic.h>
+#include <asm/irq.h>
+#include <asm/io.h>
+#include <asm/arch/irq.h>
+
+asmlinkage void asm_do_IRQ(int irq,
+			   struct pt_regs *regs);
+
+struct pt_regs __adeos_irq_regs;
+
+/* adeos_critical_enter() -- Grab the superlock for entering a global
+   critical section. On this uniprocessor-only arch, this is identical
+   to hw cli(). */
+
+unsigned long adeos_critical_enter (void (*syncfn)(void))
+
+{
+    unsigned long flags;
+    adeos_hw_local_irq_save(flags);
+    return flags;
+}
+
+/* adeos_critical_exit() -- Release the superlock. */
+
+void adeos_critical_exit (unsigned long flags) {
+
+    adeos_hw_local_irq_restore(flags);
+}
+
+void __adeos_init_stage (adomain_t *adp)
+
+{
+    int cpuid, n;
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	{
+	adp->cpudata[cpuid].irq_pending_hi = 0;
+
+	for (n = 0; n < IPIPE_IRQ_IWORDS; n++)
+	    adp->cpudata[cpuid].irq_pending_lo[n] = 0;
+
+	for (n = 0; n < IPIPE_NR_IRQS; n++)
+	    adp->cpudata[cpuid].irq_hits[n] = 0;
+	}
+
+    for (n = 0; n < IPIPE_NR_IRQS; n++)
+	{
+	adp->irqs[n].acknowledge = NULL;
+	adp->irqs[n].handler = NULL;
+	adp->irqs[n].control = IPIPE_PASS_MASK;	/* Pass but don't handle */
+	}
+}
+
+/* compute number of most-significant 1-bit (100...0 -> 31, 00...01 -> 0), input
+ * must not be 0 */
+
+#if __LINUX_ARM_ARCH__ >= 5
+
+extern inline int flnz (unsigned long word)
+
+{
+    /* clz is only supported >= ARMv5 */
+    int i;
+    /* effect of "clz i, word":
+     * if (word == 0) i = 32; else i = 31 - (bit position of most significant '1' in word) */
+    __asm__(
+	"clz %0, %1"
+	: /* output */ "=r" (i)
+	: /* input */  "r"  (word)
+    );
+    /* word != 0 => i = 31 - (bit position of most significant '1' in word) */
+    return 31 - i;
+}
+
+#else /* __LINUX_ARM_ARCH__ < 5 */
+
+static int flnz (unsigned long word)
+
+{
+    int i = 0;
+
+    if ((word & 0xFFFF0000UL) != 0) {
+	word >>= 16;
+	i += 16;
+    }
+    if ((word & 0xFF00UL) != 0) {
+	word >>= 8;
+	i += 8;
+    }
+    if ((word & 0xF0UL) != 0) {
+	word >>= 4;
+	i += 4;
+    }
+    if ((word & 0xCUL) != 0) {
+	word >>= 2;
+	i += 2;
+    }
+    if ((word & 0x2UL) != 0)
+	i += 1;
+    return i;
+}
+
+#endif /* __LINUX_ARM_ARCH__ >= 5 */
+
+/* __adeos_sync_stage() -- Flush the pending IRQs for the current
+   domain (and processor).  This routine flushes the interrupt log
+   (see "Optimistic interrupt protection" from D. Stodolsky et al. for
+   more on the deferred interrupt scheme). Every interrupt that
+   occurred while the pipeline was stalled gets played.  WARNING:
+   callers on SMP boxen should always check for CPU migration on
+   return of this routine. One can control the kind of interrupts
+   which are going to be sync'ed using the syncmask
+   parameter. IPIPE_IRQMASK_ANY plays them all, IPIPE_IRQMASK_VIRT
+   plays virtual interrupts only. This routine must be called with hw
+   interrupts off. */
+
+void __adeos_sync_stage (unsigned long syncmask)
+
+{
+    unsigned long mask, submask;
+    struct adcpudata *cpudata;
+    adeos_declare_cpuid;
+    int level, rank;
+    adomain_t *adp;
+    unsigned irq;
+
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled());
+
+    adeos_load_cpuid();
+    adp = adp_cpu_current[cpuid];
+    cpudata = &adp->cpudata[cpuid];
+
+    do
+	{
+	/* The policy here is to keep the dispatching code
+	   interrupt-free by stalling the current stage. If the upper
+	   domain handler (which we call) wants to re-enable
+	   interrupts while in a safe portion of the code
+	   (e.g. SA_INTERRUPT flag unset for Linux's sigaction()), it
+	   will have to unstall (then stall again before returning to
+	   us!) the stage when it sees fit. */
+
+	while ((mask = (cpudata->irq_pending_hi & syncmask)) != 0)
+	    {
+	    /* Give a slight priority advantage to high-numbered IRQs
+	       like the virtual ones. */
+	    level = flnz(mask);
+	    __clear_bit(level,&cpudata->irq_pending_hi);
+
+	    while ((submask = cpudata->irq_pending_lo[level]) != 0)
+		{
+		rank = flnz(submask);
+		irq = (level << IPIPE_IRQ_ISHIFT) + rank;
+
+		if (test_bit(IPIPE_LOCK_FLAG,&adp->irqs[irq].control))
+		    {
+		    __clear_bit(rank,&cpudata->irq_pending_lo[level]);
+		    continue;
+		    }
+
+		if (--cpudata->irq_hits[irq] == 0)
+		    __clear_bit(rank,&cpudata->irq_pending_lo[level]);
+
+		/* Allow the sync routine to be reentered on behalf of
+		   the IRQ handler and any execution context switched
+		   in by the IRQ handler. The latter also means that
+		   returning from the switched out context is always
+		   safe even if the sync routine has been reentered in
+		   the meantime. */
+
+		__set_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+#ifdef CONFIG_ADEOS_PROFILING
+		__adeos_profile_data[cpuid].irqs[irq].n_synced++;
+		adeos_hw_tsc(__adeos_profile_data[cpuid].irqs[irq].t_synced);
+#endif /* CONFIG_ADEOS_PROFILING */
+
+		if (adp == adp_root)
+		    adeos_hw_sti();
+
+		((void (*)(unsigned, struct pt_regs *))adp->irqs[irq].handler)(irq,&__adeos_irq_regs);
+
+		adeos_hw_cli();
+
+		__clear_bit(IPIPE_STALL_FLAG,&cpudata->status);
+		}
+	    }
+	}
+    while ((cpudata->irq_pending_hi & syncmask) != 0);
+}
+
+/* __adeos_walk_pipeline(): Must be called with local interrupts
+   disabled. */
+
+static inline void __adeos_walk_pipeline (struct list_head *pos, int cpuid)
+
+{
+    adomain_t *this_domain = adp_cpu_current[cpuid];
+
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled());
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *next_domain = list_entry(pos,adomain_t,p_link);
+
+	if (test_bit(IPIPE_STALL_FLAG,&next_domain->cpudata[cpuid].status))
+	    break; /* Stalled stage -- do not go further. */
+
+	if (next_domain->cpudata[cpuid].irq_pending_hi != 0)
+	    {
+	    if (next_domain == this_domain)
+		__adeos_sync_stage(IPIPE_IRQMASK_ANY);
+	    else
+		{
+		__adeos_switch_to(this_domain,next_domain,cpuid);
+
+		adeos_load_cpuid(); /* Processor might have changed. */
+
+		if (!test_bit(IPIPE_STALL_FLAG,&this_domain->cpudata[cpuid].status) &&
+		    this_domain->cpudata[cpuid].irq_pending_hi != 0)
+		    __adeos_sync_stage(IPIPE_IRQMASK_ANY);
+		}
+
+	    break;
+	    }
+	else if (next_domain == this_domain)
+	    break;
+
+	pos = next_domain->p_link.next;
+	}
+}
+
+/* __adeos_handle_irq() -- ADEOS's generic IRQ handler. An optimistic
+   interrupt protection log is maintained here for each domain.
+   Interrupts are off on entry.
+   Please note that this function is never called if RTAI immediate interrupt
+   dispatching is active (see entry-armv.S and arm/hal.c) */
+
+asmlinkage int __adeos_handle_irq (int irq, struct pt_regs *regs)
+
+{
+    struct list_head *head, *pos;
+    adeos_declare_cpuid;
+    int m_ack, s_ack;
+
+    ADEOS_PARANOIA_ASSERT(adeos_hw_irqs_disabled());
+
+    m_ack = irq & 0x100;
+    irq &= 0xff;
+
+    if (unlikely(!adp_pipelined))
+	{
+	/* Note that according to Russel King asm_do_IRQ() has to be called (at
+	 * least for 2.4.21-rmk7), not do_IRQ() as the original ADEOS code had
+	 * here. <mike@firmix.at> */
+	asm_do_IRQ(irq,regs);
+	return 1; /* do Linux return-to-user stuff */
+	}
+
+    if (!adeos_virtual_irq_p(irq))
+	irq = fixup_irq(irq);
+
+    if (irq >= IPIPE_NR_IRQS)
+	{
+	printk(KERN_ERR "ADEOS: spurious interrupt %d\n",irq);
+	goto out;
+	}
+
+    adeos_load_cpuid();
+
+#ifdef CONFIG_ADEOS_PROFILING
+    __adeos_profile_data[cpuid].irqs[irq].n_handled++;
+    adeos_hw_tsc(__adeos_profile_data[cpuid].irqs[irq].t_handled);
+#endif /* CONFIG_ADEOS_PROFILING */
+
+    s_ack = m_ack;
+
+    if (unlikely(test_bit(IPIPE_STICKY_FLAG,&adp_cpu_current[cpuid]->irqs[irq].control)))
+	head = &adp_cpu_current[cpuid]->p_link;
+    else
+	head = __adeos_pipeline.next;
+
+    /* Ack the interrupt. */
+
+    pos = head;
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *next_domain = list_entry(pos,adomain_t,p_link);
+
+	/* For each domain handling the incoming IRQ, mark it as
+           pending in its log. */
+
+	if (test_bit(IPIPE_HANDLE_FLAG,&next_domain->irqs[irq].control))
+	    {
+	    /* Domains that handle this IRQ are polled for
+	       acknowledging it by decreasing priority order. The
+	       interrupt must be made pending _first_ in the domain's
+	       status flags before the PIC is unlocked. */
+
+	    next_domain->cpudata[cpuid].irq_hits[irq]++;
+	    __adeos_set_irq_bit(next_domain,cpuid,irq);
+
+	    /* Always get the first master acknowledge available. Once
+	       we've got it, allow slave acknowledge handlers to run
+	       (until one of them stops us). */
+
+	    if (!m_ack)
+		m_ack = next_domain->irqs[irq].acknowledge(irq);
+	    else if (test_bit(IPIPE_SHARED_FLAG,&next_domain->irqs[irq].control) && !s_ack)
+		s_ack = next_domain->irqs[irq].acknowledge(irq);
+	    }
+
+	/* If the domain does not want the IRQ to be passed down the
+	   interrupt pipe, exit the loop now. */
+
+	if (!test_bit(IPIPE_PASS_FLAG,&next_domain->irqs[irq].control))
+	    break;
+
+	pos = next_domain->p_link.next;
+	}
+
+    if (likely(irq == ADEOS_TIMER_IRQ))
+	{
+	__adeos_irq_regs.ARM_cpsr = regs->ARM_cpsr;
+	__adeos_irq_regs.ARM_pc = regs->ARM_pc;
+	}
+
+    /* Now walk the pipeline, yielding control to the highest priority
+       domain that has pending interrupt(s) or immediately to the
+       current domain if the interrupt has been marked as
+       'sticky'. This search does not go beyond the current domain in
+       the pipeline. To understand this code properly, one must keep
+       in mind that domains having a higher priority than the current
+       one are sleeping on the adeos_suspend_domain() service. In
+       addition, domains having a lower priority have been preempted
+       by an interrupt dispatched to a more prioritary domain. Once
+       the first and most prioritary stage has been selected here, the
+       subsequent stages will be activated in turn when each visited
+       domain calls adeos_suspend_domain() to wake up its neighbour
+       down the pipeline. */
+
+    __adeos_walk_pipeline(head,cpuid);
+
+    adeos_load_cpuid();
+
+out:
+    /* Tell entry-code if it should perform Linux stuff when returning to user
+     * space (return != 0) or not (return == 0). (Linux doesn't expect
+     * schedule() etc. to be called when interrupts are disabled from its
+     * perspective (i.e. root-ipipe is stalled) or current domain is not Linux.) */
+    return (adp_cpu_current[cpuid] == adp_root &&
+	    !test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status));
+}
+
+/* adeos_trigger_irq() -- Push the interrupt to the pipeline entry
+   just like if it has been actually received from a hw source. This
+   both works for real and virtual interrupts. This also means that
+   the current domain might be immediately preempted by a more
+   prioritary domain who happens to handle this interrupt. */
+
+int adeos_trigger_irq (unsigned irq)
+
+{
+    struct pt_regs regs;
+    unsigned long flags;
+
+    if (irq >= IPIPE_NR_IRQS ||
+	(adeos_virtual_irq_p(irq) && !test_bit(irq - IPIPE_VIRQ_BASE,&__adeos_virtual_irq_map)))
+	return -EINVAL;
+
+    adeos_hw_local_irq_save(flags);
+
+    regs.ARM_cpsr = flags;
+
+    __adeos_handle_irq(irq | 0x100,&regs);
+
+    adeos_hw_local_irq_restore(flags);
+
+    return 1;
+}
+
+extern inline void __save_root_stall_flag_to_ibit (struct pt_regs *regs)
+
+{
+    adeos_declare_cpuid;
+    if (test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status))
+	regs->ARM_cpsr |= I_BIT;
+    else
+	regs->ARM_cpsr &= ~I_BIT;
+}
+
+/* Save the root's domain stall bit in the user's CPSR I-bit (assumption:
+ * hw-interrupt are always enabled in user-space) so that the proper pipeline
+ * state for the root stage can be restored when returning from one of the
+ * following exception:
+ * 	swi (swi should (can?) only be used in user mode!)
+ * 	irq in user mode
+ * 	undefined instruction in user mode
+ * 	data abort in user mode
+ * 	prefetch abort in user mode
+ * 	return from fork (returns to user mode)
+ *  i.e. all those that go through ret_fast_syscall, ret_disable_irq or
+ *  ret_to_user, see entry-common.S and entry-armv.S */
+asmlinkage void __adeos_user_exception_save_root (struct pt_regs *regs)
+
+{
+    if (likely(adp_pipelined))
+	__save_root_stall_flag_to_ibit(regs);
+}
+
+asmlinkage int __adeos_enter_syscall (struct pt_regs *regs, int scno)
+
+{
+    /* hw-irqs are enabled when this function is entered */
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_PROLOGUE] > 0))
+	{
+	long oldip = regs->ARM_ip;
+	int stop_event;
+
+	ADEOS_PARANOIA_ASSERT(!adeos_hw_irqs_disabled());
+
+	regs->ARM_ip = scno;
+	stop_event = __adeos_handle_event(ADEOS_SYSCALL_PROLOGUE,regs);
+	regs->ARM_ip = oldip;
+
+	/* We might enter here over a non-root domain and exit over
+	 * the root one as a result of the issued syscall, so the interrupt
+	 * flag might not have been fixed-up during entering the kernel.
+	 * If the event is propageted (i.e. linux handles the syscall) we
+	 * need to fix up the interrupt flag as
+	 * __adeos_user_exception_save_root() is called upon returning to user
+	 * space. */
+	if (!stop_event)
+	    __save_root_stall_flag_to_ibit(regs);
+
+	return stop_event;
+	}
+
+    return 0;
+}
+
+asmlinkage int __adeos_exit_syscall (void)
+
+{
+    /* hw-irqs are enabled when this function is entered */
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_EPILOGUE] > 0))
+	return __adeos_handle_event(ADEOS_SYSCALL_EPILOGUE,NULL);
+
+    return 0;
+}
+
+asmlinkage void __adeos_ret_to_user_restore_root (struct pt_regs *regs)
+
+{
+    adeos_declare_cpuid;
+
+    if (unlikely(!adp_pipelined))
+	return;
+
+    ADEOS_PARANOIA_ASSERT(!adeos_hw_irqs_disabled());
+
+    /* Restore root's ipipe stall state as it used to be on kernel entry.
+     * Side-effect: hw-irqs are forced to be enabled in user-mode. */
+
+    if (regs->ARM_cpsr & I_BIT)
+	{
+	regs->ARM_cpsr &= ~I_BIT;
+	adeos_hw_cli();
+	__set_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status);
+	}
+    else
+	{
+	adeos_hw_cli();
+	__clear_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status);
+
+	/* Sync all IRQs here, who knows when the next interrupt will happen 
+	 * (only then will the stage be synced!). */
+	if (adp_root->cpudata[cpuid].irq_pending_hi != 0)
+	    __adeos_sync_stage(IPIPE_IRQMASK_ANY);
+	}
+    /* We return with hw-irqs disabled, ready for restoring registers. */
+}
+
+/* default handler for Adeos syscall (will be replaced by non-root domain, e.g.
+ * RTAI for LXRT calls and SRQs */
+asmlinkage int __adeos_handle_syscall(struct pt_regs *regs)
+
+{
+    /* just return error code and do fast return from syscall */
+    *(long long*)&regs->ARM_r0 = -ENODEV;
+    return 1;
+}
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/armksyms.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/armksyms.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/arch/arm/kernel/armksyms.c	2004-07-22 13:48:58.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/arch/arm/kernel/armksyms.c	2005-08-12 15:41:58.000000000 -0600
@@ -56,6 +56,7 @@ extern int sys_exit(int);
  */
 extern void __ashldi3(void);
 extern void __ashrdi3(void);
+extern void __divdi3(void);
 extern void __divsi3(void);
 extern void __lshrdi3(void);
 extern void __modsi3(void);
@@ -86,6 +87,36 @@ extern void __do_softirq(void);
   __attribute__((section("__ksymtab"))) =	\
     { (unsigned long)&orig, __kstrtab_##sym };
 
+#ifdef CONFIG_ADEOS_CORE
+#ifdef CONFIG_ADEOS_MODULE
+EXPORT_SYMBOL(adp_pipelined);
+#include <asm/arch/irq.h>
+EXPORT_SYMBOL(asm_do_IRQ);
+#endif /* CONFIG_ADEOS_MODULE */
+EXPORT_SYMBOL(adeos_critical_enter);
+EXPORT_SYMBOL(adeos_critical_exit);
+EXPORT_SYMBOL(adeos_trigger_irq);
+EXPORT_SYMBOL(__adeos_sync_stage);
+EXPORT_SYMBOL(__adeos_irq_regs);
+EXPORT_SYMBOL(__adeos_tune_timer);
+#ifdef CONFIG_ADEOS_THREADS
+EXPORT_SYMBOL(__adeos_switch_domain);
+#endif /* CONFIG_ADEOS_THREADS */
+EXPORT_SYMBOL(__adeos_handle_irq);
+/* The following are per-platform convenience exports which are needed
+   by some Adeos domains loaded as kernel modules. */
+extern struct irqdesc irq_desc[];
+EXPORT_SYMBOL_NOVERS(irq_desc);
+EXPORT_SYMBOL_NOVERS(__switch_to);
+extern void show_regs(struct pt_regs * regs);
+EXPORT_SYMBOL_NOVERS(show_regs);
+EXPORT_SYMBOL(adeos_syscall_entry);
+EXPORT_SYMBOL(adeos_irq_entry);
+EXPORT_SYMBOL(adeos_root_domain);
+/* for debugging */
+EXPORT_SYMBOL(__backtrace);
+#endif /* CONFIG_ADEOS_CORE */
+
 /*
  * floating point math emulator support.
  * These symbols will never change their calling convention...
@@ -227,6 +258,7 @@ EXPORT_SYMBOL_NOVERS(__put_user_8);
 	/* gcc lib functions */
 EXPORT_SYMBOL_NOVERS(__ashldi3);
 EXPORT_SYMBOL_NOVERS(__ashrdi3);
+EXPORT_SYMBOL_NOVERS(__divdi3);
 EXPORT_SYMBOL_NOVERS(__divsi3);
 EXPORT_SYMBOL_NOVERS(__lshrdi3);
 EXPORT_SYMBOL_NOVERS(__modsi3);
